//-------------------------------------------------------------------
//!ۃEBhENXwb_
//!@memo 08/05/09 mmm
//-------------------------------------------------------------------

#ifndef __MMM_AWINDOW_H__
#define __MMM_AWINDOW_H__

#include <windows.h>						//CN[ht@C
#include <list>

#include "MMMStd.h"

namespace mmm
{
	//-------------------------------------------------------------------
	//!ۃEBhENX
	//-------------------------------------------------------------------
	class AWindow
	{
	public:
		//RXgN^ŃX^C̏ƃReiւ̓o^s
		AWindow() : hWnd_(0), style_(WS_OVERLAPPEDWINDOW), styleEx_(0), active_(false)
		{
			strcpy_s(registerName_, REGISTER_NAME_MAX_LENGTH, "DEFAULT");
			windowList_.push_back(this);
		}
		//fXgN^ŃRei폜
		virtual ~AWindow()
		{
			windowList_.remove(this);
		}
	private:
		//!ŏɌĂ΂O[oȃvV[W֐
		static LRESULT CALLBACK GlobalProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	private:
		//!hNX̃I[o[ChpvV[W֐
		virtual LRESULT	CALLBACK MyProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) = 0;
	protected:
		//!hNXpWvV[W֐
		virtual LRESULT	CALLBACK MyDefProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	public:
		//!EBhENX̓o^֐
		bool Register(HINSTANCE hInst);
		//!EBhE̐֐@Register()Ă邱ƂO
		bool Create(HINSTANCE hInst);
	public:
		//!EBhE֐@ɌĂԂ
		void Open()
		{
			ShowWindow(hWnd_, SW_SHOW);
		}
		//!EBhẼ^Cgo[̕\ݒ֐@ɌĂԂ
		void SetTitle(const char* title)
		{
			SetWindowText(hWnd_, (LPCSTR)title);
		}
		//!EBhẼXN[TCYiNCAg̈̑傫jݒ֐@ɌĂԂ
		void SetScreenSize(int w, int h);
		//!EBhËʒuʒSɈړ֐@ɌĂԂ
		void MoveDisplayCenter();
	public:
		bool IsActive(){ return active_; }
		HWND GetHandle(){ return hWnd_; }
		int GetStyle(){ return style_; }
		int GetStyleEx(){ return styleEx_; }
		LPCSTR GetRegisterName(){ return registerName_; }

		void SetStyle(int style){ style_ = style; }
		void SetStyleEx(int styleEx){ styleEx_ = styleEx; }
		void SetRegisterName(LPCSTR name){ strcpy_s(registerName_, REGISTER_NAME_MAX_LENGTH, name); }
	private:
		//!o^̍ő咷
		enum{REGISTER_NAME_MAX_LENGTH = 32};
	private:
		HWND hWnd_;										//!<EBhEnh
		int style_;										//!<X^C
		int styleEx_;									//!<gX^C
		CHAR registerName_[REGISTER_NAME_MAX_LENGTH];	//!<o^
		bool active_;									//!<̃EBhEANeBuǂ
	private:
		static std::list<AWindow*> windowList_;		//!<ς݃EBhẼRei
	};

	//!EBhEp֗֐
	bool CreateWindowUTL(mmm::AWindow* pW, HINSTANCE hInst, int w, int h, const LPCSTR pTitle);
};

#endif
