//-------------------------------------------------------------------
//!MMMOԗp{wb_
//!@memo 08/05/29 mmm
//-------------------------------------------------------------------

#ifndef __MMM_STD_H__
#define __MMM_STD_H__

#include <cassert>
#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <tchar.h>
#include <stdarg.h>

//!fobOprhǂ
#ifdef _DEBUG
	#define MMM_DEBUG
#endif

//!uW̊g@\łBv
#pragma warning(disable : 4201) 

//fobOƃ[Xœς}N`
#ifdef MMM_DEBUG
	#define MMM_HALT(str)	{assert(str && __LINE__ && __FILE__ && 0);}
	#define MMM_CHECK(expr)	{assert(expr && __LINE__ && __FILE__);}
	#define MMM_CHECK_INDEX(id, min, max)	{assert(min <= id && id <= max && __LINE__ && __FILE__);}
#else
	#define MMM_HALT(str)	//
	#define MMM_CHECK_INDEX	//
	#define MMM_CHECK		//
#endif

//fobO[NΌĂяoƂ̃t@Cƍso
#ifdef MMM_DEBUG
	#define debug_new  ::new( _NORMAL_BLOCK, __FILE__, __LINE__ )
#else
	#define debug_new  ::new
#endif

//ANZbT`p}N
#define MMM_PROPERTY_G(type, funcName, memberName) type Get##funcName() const { return memberName; }
#define MMM_PROPERTY_S(type, funcName, memberName) void Set##funcName(type arg){ memberName = arg; }
#define MMM_PROPERTY_GS(type, funcName, memberName)	\
	MMM_PROPERTY_G(type, funcName, memberName)		\
	MMM_PROPERTY_S(type, funcName, memberName)

#define MMM_PROPERTY_GSD(type, funcName, memberName)		\
	public:												\
		MMM_PROPERTY_G(type, funcName, memberName)		\
		MMM_PROPERTY_S(type, funcName, memberName)		\
	private:											\
		type memberName;

#include "MMMMath.h"

#endif
